Index: branches/1.3/gui/scripts/vtkviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkviewer.tcl	(revision 4828)
+++ branches/1.3/gui/scripts/vtkviewer.tcl	(revision 4848)
@@ -1,3 +1,4 @@
 # -*- mode: tcl; indent-tabs-mode: nil -*- 
+
 # ----------------------------------------------------------------------
 #  COMPONENT: vtkviewer - Vtk drawing object viewer
@@ -7,5 +8,5 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2014  HUBzero Foundation, LLC
+#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 #
 #  See the file "license.terms" for information on usage and
@@ -57,5 +58,5 @@
     public method get {args}
     public method isconnected {}
-    public method limits { dataobj }
+    public method limits { colormap }
     public method parameters {title args} { 
         # do nothing 
@@ -63,6 +64,21 @@
     public method scale {args}
 
+    protected method Connect {}
+    protected method CurrentDatasets {args}
+    protected method Disconnect {}
+    protected method DoResize {}
+    protected method DoRotate {}
+    protected method AdjustSetting {what {value ""}}
+    protected method FixSettings { args  }
+    protected method Pan {option x y}
+    protected method Pick {x y}
+    protected method Rebuild {}
+    protected method ReceiveDataset { args }
+    protected method ReceiveImage { args }
+    protected method ReceiveLegend { colormap title vmin vmax size }
+    protected method Rotate {option x y}
+    protected method Zoom {option}
+
     # The following methods are only used by this class.
-    private method AdjustSetting {what {value ""}}
     private method BuildAxisTab {}
     private method BuildCameraTab {}
@@ -70,45 +86,26 @@
     private method BuildCutawayTab {}
     private method BuildDownloadPopup { widget command } 
-    private method BuildGlyphsTab {}
     private method BuildMoleculeTab {}
     private method BuildPolydataTab {}
     private method ChangeColormap { dataobj comp color }
-    private method Connect {}
-    private method CurrentDatasets {args}
-    private method Disconnect {}
-    private method DoResize {}
-    private method DoRotate {}
     private method DrawLegend {}
     private method EnterLegend { x y } 
-    private method EventuallyResize { w h } 
-    private method EventuallyRotate { q } 
     private method EventuallySetAtomScale { args } 
     private method EventuallySetBondScale { args } 
-    private method EventuallySetGlyphsOpacity { args } 
     private method EventuallySetMoleculeOpacity { args } 
     private method EventuallySetMoleculeQuality { args } 
     private method EventuallySetPolydataOpacity { args } 
+    private method EventuallyResize { w h } 
+    private method EventuallyRotate { q } 
     private method GetImage { args } 
     private method GetVtkData { args } 
-    private method InitSettings { args  }
     private method IsValidObject { dataobj } 
     private method LeaveLegend {}
     private method MotionLegend { x y } 
-    private method Pan {option x y}
     private method PanCamera {}
-    private method Pick {x y}
-    private method QuaternionToView { q } { 
-        foreach { _view(-qw) _view(-qx) _view(-qy) _view(-qz) } $q break
-    }
-    private method Rebuild {}
-    private method ReceiveDataset { args }
-    private method ReceiveImage { args }
-    private method ReceiveLegend { colormap title vmin vmax size }
     private method RequestLegend {}
-    private method Rotate {option x y}
     private method SetAtomScale {}
     private method SetBondScale {}
     private method SetColormap { dataobj comp }
-    private method SetGlyphsOpacity {}
     private method SetLegendTip { x y }
     private method SetMoleculeOpacity {}
@@ -119,8 +116,4 @@
     private method SetPolydataOpacity {}
     private method Slice {option args} 
-    private method ViewToQuaternion {} { 
-        return [list $_view(-qw) $_view(-qx) $_view(-qy) $_view(-qz)]
-    }
-    private method Zoom {option}
 
     private variable _arcball ""
@@ -164,4 +157,5 @@
     private variable _polydataOpacityPending 0
     private variable _glyphsOpacityPending 0
+    private variable _updatePending 0;
     private variable _rotateDelay 150
     private variable _scaleDelay 100
@@ -187,4 +181,8 @@
     $_dispatcher register !resize
     $_dispatcher dispatch $this !resize "[itcl::code $this DoResize]; list"
+
+    # Update state event
+    $_dispatcher register !update
+    $_dispatcher dispatch $this !update "[itcl::code $this DoUpdate]; list"
 
     # Rotate event
@@ -216,30 +214,25 @@
     $_dispatcher dispatch $this !polydataOpacity \
         "[itcl::code $this SetPolydataOpacity]; list"
-
-    # Glyphs opacity event
-    $_dispatcher register !glyphsOpacity
-    $_dispatcher dispatch $this !glyphsOpacity \
-        "[itcl::code $this SetGlyphsOpacity]; list"
-
     #
     # Populate parser with commands handle incoming requests
     #
-    $_parser alias image [itcl::code $this ReceiveImage]
-    $_parser alias dataset [itcl::code $this ReceiveDataset]
-    $_parser alias legend [itcl::code $this ReceiveLegend]
+    $_parser alias image    [itcl::code $this ReceiveImage]
+    $_parser alias dataset  [itcl::code $this ReceiveDataset]
+    $_parser alias legend   [itcl::code $this ReceiveLegend]
 
     # Initialize the view to some default parameters.
     array set _view {
-        -ortho           0
-        -qw              0.853553
-        -qx              -0.353553
-        -qy              0.353553
-        -qz              0.146447
-        -xpan            0
-        -ypan            0
-        -zoom            1.0
+        qw              0.853553
+        qx              -0.353553
+        qy              0.353553
+        qz              0.146447
+        zoom            1.0 
+        xpan            0
+        ypan            0
+        ortho           0
     }
     set _arcball [blt::arcball create 100 100]
-    $_arcball quaternion [ViewToQuaternion]
+    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+    $_arcball quaternion $q
 
     set _limits(zmin) 0.0
@@ -247,7 +240,4 @@
 
     array set _axis [subst {
-        labels          1
-        minorticks      1
-        visible         1
         xgrid           0
         ygrid           0
@@ -262,24 +252,26 @@
         ydirection      -1
         zdirection      -1
+        visible         1
+        labels          1
     }]
     array set _settings [subst {
-        glyphs-edges            0
-        glyphs-lighting         1
+        legend                  1
         glyphs-opacity          100
-        glyphs-outline          0
-        glyphs-palette          BCGYR
-        glyphs-visible          1
         glyphs-wireframe        0
-        legend                  1
-        molecule-atoms-visible  1
+        polydata-edges          0
+        polydata-lighting       1
+        polydata-opacity        100
+        polydata-palette        rainbow
+        polydata-visible        1
+        polydata-wireframe      0
         molecule-atomscale      0.3
-        molecule-bonds-visible  1
         molecule-bondscale      0.075
         molecule-bondstyle      "cylinder"
+        molecule-atoms-visible  1
+        molecule-bonds-visible  1
         molecule-edges          0
         molecule-labels         0
         molecule-lighting       1
         molecule-opacity        100
-        molecule-outline        0
         molecule-palette        elementDefault
         molecule-quality        1.0
@@ -288,11 +280,4 @@
         molecule-visible        1
         molecule-wireframe      0
-        polydata-edges          0
-        polydata-lighting       1
-        polydata-opacity        100
-        polydata-outline        0
-        polydata-palette        BCGYR
-        polydata-visible        1
-        polydata-wireframe      0
     }]
     itk_component add view {
@@ -362,13 +347,10 @@
     Rappture::Tooltip::for $itk_component(zoomout) "Zoom out"
 
-    if { [catch {
-        BuildAxisTab
-        #BuildCutawayTab
-        BuildCameraTab
-    } errs] != 0 } {
-        puts stderr errs=$errs
-    }
+    BuildAxisTab
+    #BuildCutawayTab
+    BuildCameraTab
 
     # Legend
+
     set _image(legend) [image create photo]
     itk_component add legend {
@@ -396,4 +378,6 @@
     bind $itk_component(view) <ButtonRelease-1> \
         [itcl::code $this Rotate release %x %y]
+    bind $itk_component(view) <Configure> \
+        [itcl::code $this EventuallyResize %w %h]
 
     # Bindings for panning via mouse
@@ -473,5 +457,6 @@
 
 itcl::body Rappture::VtkViewer::DoRotate {} {
-    SendCmd "camera orient [ViewToQuaternion]" 
+    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+    SendCmd "camera orient $q" 
     set _rotatePending 0
 }
@@ -488,5 +473,5 @@
 
 itcl::body Rappture::VtkViewer::EventuallyRotate { q } {
-    QuaternionToView $q
+    foreach { _view(qw) _view(qx) _view(qy) _view(qz) } $q break
     if { !$_rotatePending } {
         set _rotatePending 1
@@ -521,14 +506,4 @@
 }
 
-itcl::body Rappture::VtkViewer::SetGlyphsOpacity {} {
-    set _glyphsOpacityPending 0
-    foreach dataset [CurrentDatasets -visible $_first] {
-        foreach { dataobj comp } [split $dataset -] break
-        if { [$dataobj type $comp] == "glyphs" } {
-            SetOpacity $dataset
-        }
-    }
-}
-
 itcl::body Rappture::VtkViewer::SetPolydataOpacity {} {
     set _polydataOpacityPending 0
@@ -573,11 +548,4 @@
         set _polydataOpacityPending 1
         $_dispatcher event -after $_scaleDelay !polydataOpacity
-    }
-}
-
-itcl::body Rappture::VtkViewer::EventuallySetGlyphsOpacity { args } {
-    if { !$_glyphsOpacityPending } {
-        set _glyphsOpacityPending 1
-        $_dispatcher event -after $_scaleDelay !glyphsOpacity
     }
 }
@@ -748,30 +716,23 @@
         }
         array set bounds [limits $dataobj]
-        if {[info exists bounds(xmin)] && (![info exists _limits(xmin)] || $_limits(xmin) > $bounds(xmin))} {
+        if {![info exists _limits(xmin)] || $_limits(xmin) > $bounds(xmin)} {
             set _limits(xmin) $bounds(xmin)
         }
-        if {[info exists bounds(xmax)] && (![info exists _limits(xmax)] || $_limits(xmax) < $bounds(xmax))} {
+        if {![info exists _limits(xmax)] || $_limits(xmax) < $bounds(xmax)} {
             set _limits(xmax) $bounds(xmax)
         }
 
-        if {[info exists bounds(ymin)] && (![info exists _limits(ymin)] || $_limits(ymin) > $bounds(ymin))} {
+        if {![info exists _limits(ymin)] || $_limits(ymin) > $bounds(ymin)} {
             set _limits(ymin) $bounds(ymin)
         }
-        if {[info exists bounds(ymax)] && (![info exists _limits(ymax)] || $_limits(ymax) < $bounds(ymax))} {
+        if {![info exists _limits(ymax)] || $_limits(ymax) < $bounds(ymax)} {
             set _limits(ymax) $bounds(ymax)
         }
 
-        if {[info exists bounds(zmin)] && (![info exists _limits(zmin)] || $_limits(zmin) > $bounds(zmin))} {
+        if {![info exists _limits(zmin)] || $_limits(zmin) > $bounds(zmin)} {
             set _limits(zmin) $bounds(zmin)
         }
-        if {[info exists bounds(zmax)] && (![info exists _limits(zmax)] || $_limits(zmax) < $bounds(zmax))} {
+        if {![info exists _limits(zmax)] || $_limits(zmax) < $bounds(zmax)} {
             set _limits(zmax) $bounds(zmax)
-        }
-    }
-    if { $_haveGlyphs } {
-        if { ![$itk_component(main) exists "Glyphs Settings"] } {
-            if { [catch { BuildGlyphsTab } errs ]  != 0 } {
-                puts stderr "errs=$errs"
-            }
         }
     }
@@ -867,5 +828,5 @@
         if { $_reportClientInfo }  {
             # Tell the server the viewer, hub, user and session.
-            # Do this immediately on connect before buffering any commands
+            # Do this immediately on connect before buffing any commands
             global env
 
@@ -924,5 +885,4 @@
 
     # disconnected -- no more data sitting on server
-    set _outbuf ""
     array unset _datasets 
     array unset _data 
@@ -951,5 +911,5 @@
     if { $info(-type) == "image" } {
         if 0 {
-            set f [open "last.ppm" "w"]
+            set f [open "last.ppm" "w"] 
             fconfigure $f -encoding binary
             puts -nonewline $f $bytes
@@ -1037,7 +997,11 @@
         $_arcball resize $w $h
         DoResize
-        InitSettings axis-xgrid axis-ygrid axis-zgrid axis-mode \
-            axis-visible axis-labels axis-minorticks
-
+        FixSettings axis-xgrid axis-ygrid axis-zgrid axis-mode \
+            axis-visible axis-labels
+
+        if { $_havePolydata } {
+            FixSettings polydata-edges polydata-lighting polydata-opacity \
+                polydata-visible polydata-wireframe 
+        }
         StopBufferingCommands
         SendCmd "imgflush"
@@ -1061,10 +1025,4 @@
                 if { $bytes == "" } {
                     continue
-                }
-                if 0 {
-                    set f [open /tmp/vtkviewer.vtk "w"]
-                    fconfigure $f -translation binary -encoding binary
-                    puts -nonewline $f $bytes
-                    close $f
                 }
                 set length [string length $bytes]
@@ -1079,5 +1037,5 @@
                     lappend info "dataset_size"  $length
                     lappend info "dataset_tag"   $tag
-                    SendCmd "clientinfo [list $info]"
+                    SendCmd [list "clientinfo" $info]
                 }
                 SendCmd "dataset add $tag data follows $length"
@@ -1087,7 +1045,6 @@
             }
             lappend _obj2datasets($dataobj) $tag
-            set type [$dataobj type $comp]
             if { [info exists _obj2ovride($dataobj-raise)] } {
-                SendCmd "$type visible 1 $tag"
+                SendCmd "dataset visible 1 $tag"
                 SetOpacity $tag
             }
@@ -1103,38 +1060,17 @@
             set label [$_first hints ${axis}label]
             if { $label != "" } {
-                SendCmd [list axis name $axis $label]
+                SendCmd "axis name $axis $label"
             }
             set units [$_first hints ${axis}units]
             if { $units != "" } {
-                SendCmd [list axis units $axis $units]
-            }
-        }
-    }
-    if { $_haveGlyphs } {
-        InitSettings glyphs-outline
-    }
-    if { $_haveMolecules } {
-        InitSettings molecule-outline
-    }
-    if { $_havePolydata } {
-        InitSettings polydata-outline
+                SendCmd "axis units $axis $units"
+            }
+        }
     }
     if { $_reset } {
-        if { $_haveGlyphs } {
-            InitSettings glyphs-edges glyphs-lighting glyphs-opacity \
-                glyphs-visible glyphs-wireframe 
-        }
-        if { $_havePolydata } {
-            InitSettings polydata-edges polydata-lighting polydata-opacity \
-                polydata-visible polydata-wireframe 
-        }
-        if { $_haveMolecules } {
-            InitSettings molecule-edges molecule-lighting molecule-opacity \
-                molecule-visible molecule-wireframe molecule-labels
-        }
-
-        $_arcball quaternion [ViewToQuaternion]
+        set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+        $_arcball quaternion $q 
         SendCmd "camera reset"
-        if { $_view(-ortho)} {
+        if { $_view(ortho)} {
             SendCmd "camera mode ortho"
         } else {
@@ -1147,5 +1083,5 @@
 
     if { $_haveMolecules } {
-        #InitSettings molecule-representation 
+        #FixSettings molecule-representation 
     }
     set _reset 0
@@ -1217,20 +1153,20 @@
     switch -- $option {
         "in" {
-            set _view(-zoom) [expr {$_view(-zoom)*1.25}]
-            SendCmd "camera zoom $_view(-zoom)"
+            set _view(zoom) [expr {$_view(zoom)*1.25}]
+            SendCmd "camera zoom $_view(zoom)"
         }
         "out" {
-            set _view(-zoom) [expr {$_view(-zoom)*0.8}]
-            SendCmd "camera zoom $_view(-zoom)"
+            set _view(zoom) [expr {$_view(zoom)*0.8}]
+            SendCmd "camera zoom $_view(zoom)"
         }
         "reset" {
             array set _view {
-                -qw      0.853553
-                -qx      -0.353553
-                -qy      0.353553
-                -qz      0.146447
-                -xpan    0
-                -ypan    0
-                -zoom    1.0
+                qw      0.853553
+                qx      -0.353553
+                qy      0.353553
+                qz      0.146447
+                zoom    1.0
+                xpan    0
+                ypan    0
             }
             if { $_first != "" } {
@@ -1240,5 +1176,6 @@
                 }
             }
-            $_arcball quaternion [ViewToQuaternion]
+            set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+            $_arcball quaternion $q
             DoRotate
             SendCmd "camera reset"
@@ -1248,6 +1185,6 @@
 
 itcl::body Rappture::VtkViewer::PanCamera {} {
-    set x $_view(-xpan)
-    set y $_view(-ypan)
+    set x $_view(xpan)
+    set y $_view(ypan)
     SendCmd "camera pan $x $y"
 }
@@ -1326,6 +1263,6 @@
             set x [expr $x / double($w)]
             set y [expr $y / double($h)]
-            set _view(-xpan) [expr $_view(-xpan) + $x]
-            set _view(-ypan) [expr $_view(-ypan) + $y]
+            set _view(xpan) [expr $_view(xpan) + $x]
+            set _view(ypan) [expr $_view(ypan) + $y]
             PanCamera
             return
@@ -1349,6 +1286,6 @@
             set _click(x) $x
             set _click(y) $y
-            set _view(-xpan) [expr $_view(-xpan) - $dx]
-            set _view(-ypan) [expr $_view(-ypan) - $dy]
+            set _view(xpan) [expr $_view(xpan) - $dx]
+            set _view(ypan) [expr $_view(ypan) - $dy]
             PanCamera
         }
@@ -1364,5 +1301,5 @@
 
 # ----------------------------------------------------------------------
-# USAGE: InitSettings <what> ?<value>?
+# USAGE: FixSettings <what> ?<value>?
 #
 # Used internally to update rendering settings whenever parameters
@@ -1370,5 +1307,5 @@
 # to the back end.
 # ----------------------------------------------------------------------
-itcl::body Rappture::VtkViewer::InitSettings { args } {
+itcl::body Rappture::VtkViewer::FixSettings { args } {
     foreach setting $args {
         AdjustSetting $setting
@@ -1388,76 +1325,4 @@
     }
     switch -- $what {
-        "glyphs-opacity" {
-            foreach dataset [CurrentDatasets -visible $_first] {
-                foreach { dataobj comp } [split $dataset -] break
-                if { [$dataobj type $comp] == "glyphs" } {
-                    SetOpacity $dataset
-                }
-            }
-        }
-        "glyphs-outline" {
-            set bool $_settings($what)
-            foreach dataset [CurrentDatasets -visible $_first] {
-                foreach { dataobj comp } [split $dataset -] break
-                set type [$dataobj type $comp]
-                if { $type == "glyphs" } {
-                    SendCmd "outline visible $bool $dataset"
-                }
-            }
-        }
-        "glyphs-wireframe" {
-            set bool $_settings($what)
-            foreach dataset [CurrentDatasets -visible $_first] {
-                foreach { dataobj comp } [split $dataset -] break
-                set type [$dataobj type $comp]
-                if { $type == "glyphs" } {
-                    SendCmd "$type wireframe $bool $dataset"
-                }
-            }
-        }
-        "glyphs-visible" {
-            set bool $_settings($what)
-            foreach dataset [CurrentDatasets -visible $_first] {
-                foreach { dataobj comp } [split $dataset -] break
-                set type [$dataobj type $comp]
-                if { $type == "glyphs" } {
-                    SendCmd "$type visible $bool $dataset"
-                }
-            }
-        }
-        "glyphs-lighting" {
-            set bool $_settings($what)
-            foreach dataset [CurrentDatasets -visible $_first] {
-                foreach { dataobj comp } [split $dataset -] break
-                set type [$dataobj type $comp]
-                if { $type == "glyphs" } {
-                    SendCmd "$type lighting $bool $dataset"
-                }
-            }
-        }
-        "glyphs-edges" {
-            set bool $_settings($what)
-            foreach dataset [CurrentDatasets -visible $_first] {
-                foreach { dataobj comp } [split $dataset -] break
-                set type [$dataobj type $comp]
-                if { $type == "glyphs" } {
-                    SendCmd "$type edges $bool $dataset"
-                }
-            }
-        }
-        "glyphs-palette" {
-            set palette [$itk_component(glyphspalette) value]
-            set _settings($what) $palette
-            foreach dataset [CurrentDatasets -visible $_first] {
-                foreach {dataobj comp} [split $dataset -] break
-                set type [$dataobj type $comp]
-                if { $type == "glyphs" } {
-                    ChangeColormap $dataobj $comp $palette
-                    # FIXME: fill in current selected fieldname
-                    #SendCmd "glyphs colormode scalar {} $dataset"
-                }
-            }
-            set _legendPending 1
-        }
         "polydata-opacity" {
             foreach dataset [CurrentDatasets -visible $_first] {
@@ -1468,16 +1333,6 @@
             }
         }
-        "polydata-outline" {
-            set bool $_settings($what)
-            foreach dataset [CurrentDatasets -visible $_first] {
-                foreach { dataobj comp } [split $dataset -] break
-                set type [$dataobj type $comp]
-                if { $type == "polydata" } {
-                    SendCmd "outline visible $bool $dataset"
-                }
-            }
-        }
         "polydata-wireframe" {
-            set bool $_settings($what)
+            set bool $_settings(polydata-wireframe)
             foreach dataset [CurrentDatasets -visible $_first] {
                 foreach { dataobj comp } [split $dataset -] break
@@ -1489,5 +1344,5 @@
         }
         "polydata-visible" {
-            set bool $_settings($what)
+            set bool $_settings(polydata-visible)
             foreach dataset [CurrentDatasets -visible $_first] {
                 foreach { dataobj comp } [split $dataset -] break
@@ -1499,5 +1354,5 @@
         }
         "polydata-lighting" {
-            set bool $_settings($what)
+            set bool $_settings(polydata-lighting)
             foreach dataset [CurrentDatasets -visible $_first] {
                 foreach { dataobj comp } [split $dataset -] break
@@ -1509,5 +1364,5 @@
         }
         "polydata-edges" {
-            set bool $_settings($what)
+            set bool $_settings(polydata-edges)
             foreach dataset [CurrentDatasets -visible $_first] {
                 foreach { dataobj comp } [split $dataset -] break
@@ -1520,5 +1375,5 @@
         "polydata-palette" {
             set palette [$itk_component(meshpalette) value]
-            set _settings($what) $palette
+            set _settings(polydata-palette) $palette
             foreach dataset [CurrentDatasets -visible $_first] {
                 foreach {dataobj comp} [split $dataset -] break
@@ -1533,4 +1388,6 @@
         }
         "molecule-opacity" {
+            set val $_settings(molecule-opacity)
+            set sval [expr { 0.01 * double($val) }]
             foreach dataset [CurrentDatasets -visible $_first] {
                 foreach { dataobj comp } [split $dataset -] break
@@ -1540,16 +1397,6 @@
             }
         }
-        "molecule-outline" {
-            set bool $_settings($what)
-            foreach dataset [CurrentDatasets -visible $_first] {
-                foreach { dataobj comp } [split $dataset -] break
-                set type [$dataobj type $comp]
-                if { $type == "molecule" } {
-                    SendCmd "outline visible $bool $dataset"
-                }
-            }
-        }
         "molecule-wireframe" {
-            set bool $_settings($what)
+            set bool $_settings(molecule-wireframe)
             foreach dataset [CurrentDatasets -visible $_first] {
                 foreach { dataobj comp } [split $dataset -] break
@@ -1561,5 +1408,5 @@
         }
         "molecule-visible" {
-            set bool $_settings($what)
+            set bool $_settings(molecule-visible)
             foreach dataset [CurrentDatasets -visible $_first] {
                 foreach { dataobj comp } [split $dataset -] break
@@ -1571,5 +1418,5 @@
         }
         "molecule-lighting" {
-            set bool $_settings($what)
+            set bool $_settings(molecule-lighting)
             foreach dataset [CurrentDatasets -visible $_first] {
                 foreach { dataobj comp } [split $dataset -] break
@@ -1581,5 +1428,5 @@
         }
         "molecule-edges" {
-            set bool $_settings($what)
+            set bool $_settings(molecule-edges)
             foreach dataset [CurrentDatasets -visible $_first] {
                 foreach { dataobj comp } [split $dataset -] break
@@ -1592,5 +1439,5 @@
         "molecule-palette" {
             set palette [$itk_component(moleculepalette) value]
-            set _settings($what) $palette
+            set _moelculeSettings(palette) $palette
             foreach dataset [CurrentDatasets -visible $_first] {
                 foreach {dataobj comp} [split $dataset -] break
@@ -1656,5 +1503,5 @@
                     set _settings(molecule-atoms-visible) 0
                     set _settings(molecule-bonds-visible) 1
-                    set _settings(molecule-bondstyle) line
+                    set _settings(molecule-bondstyle) cylinder
                     set _settings(molecule-atomscale) 1.0
                     set _settings(molecule-bondscale) 1.0
@@ -1677,12 +1524,10 @@
                 set type [$dataobj type $comp]
                 if { $type == "molecule" } {
-                    StartBufferingCommands
-                    SendCmd [subst {molecule rscale $_settings(molecule-rscale) $dataset}]
-                    SendCmd [subst {molecule ascale $_settings(molecule-atomscale) $dataset}]
-                    SendCmd [subst {molecule bscale $_settings(molecule-bondscale) $dataset}]
-                    SendCmd [subst {molecule bstyle $_settings(molecule-bondstyle) $dataset}]
-                    SendCmd [subst {molecule atoms $_settings(molecule-atoms-visible) $dataset}]
-                    SendCmd [subst {molecule bonds $_settings(molecule-bonds-visible) $dataset}]
-                    StopBufferingCommands
+                    SendCmd [subst {molecule rscale $_settings(molecule-rscale) $dataset
+molecule ascale $_settings(molecule-atomscale) $dataset
+molecule bscale $_settings(molecule-bondscale) $dataset
+molecule bstyle $_settings(molecule-bondstyle) $dataset
+molecule atoms $_settings(molecule-atoms-visible) $dataset
+molecule bonds $_settings(molecule-bonds-visible) $dataset}]
                 }
             }
@@ -1691,15 +1536,15 @@
             set value [$itk_component(rscale) value]
             set value [$itk_component(rscale) translate $value]
-            set _settings($what) $value
+            set _settings(molecule-rscale) $value
             foreach dataset [CurrentDatasets -visible $_first] {
                 foreach {dataobj comp} [split $dataset -] break
                 set type [$dataobj type $comp]
                 if { $type == "molecule" } {
-                    SendCmd [subst {molecule rscale $_settings($what) $dataset}]
+                    SendCmd [subst {molecule rscale $_settings(molecule-rscale) $dataset}]
                 }
             }
         }
         "molecule-labels" {
-            set bool $_settings($what)
+            set bool $_settings(molecule-labels)
             foreach dataset [CurrentDatasets -visible $_first] {
                foreach { dataobj comp } [split $dataset -] break
@@ -1717,8 +1562,4 @@
             set bool $_axis(labels)
             SendCmd "axis labels all $bool"
-        }
-        "axis-minorticks" {
-            set bool $_axis(minorticks)
-            SendCmd "axis minticks all $bool"
         }
         "axis-xgrid" {
@@ -1777,7 +1618,8 @@
     set font "Arial 8"
     set lineht [font metrics $font -linespace]
+    set c $itk_component(legend)
     set w 12
     set h [expr {$_height - 2 * ($lineht + 2)}]
-    if { $h < 1 } {
+    if { $h < 1} {
         return
     }
@@ -1885,6 +1727,6 @@
 itcl::configbody Rappture::VtkViewer::plotbackground {
     if { [isconnected] } {
-        set rgb [Color2RGB $itk_option(-plotbackground)]
-        SendCmd "screen bgcolor $rgb"
+        foreach {r g b} [Color2RGB $itk_option(-plotbackground)] break
+        SendCmd "screen bgcolor $r $g $b"
     }
 }
@@ -1895,7 +1737,7 @@
 itcl::configbody Rappture::VtkViewer::plotforeground {
     if { [isconnected] } {
-        set rgb [Color2RGB $itk_option(-plotforeground)]
-        SendCmd "axis color all $rgb"
-        SendCmd "outline color $rgb"
+        foreach {r g b} [Color2RGB $itk_option(-plotforeground)] break
+        #fix this!
+        #SendCmd "color background $r $g $b"
     }
 }
@@ -1930,8 +1772,4 @@
             file delete $tmpfile
             set output [$reader GetOutput]
-            if { $output == "" } {
-                # Invalid VTK file -- loader failed to parse
-                continue
-            }
             set _limits($tag) [$output GetBounds]
             if {$debug} {
